//--------------------------------------------------------------------//
// tH`V~[V

var renderer;		// _\
var scene;		// V[
var canvasFrame;	// `t[
var size;		// `TCY
var height;		// tH\
var volume;		// tH̐ϕ\
var floor;		// 
var drop;		// tH
var ht;			// tH
var vol;		// tH̐
var directionalLight;	// s
var ambientLight;	// 
var camera;		// J
var trackball;		// gbN{[Rg[

// A_X|oVtH[X|[g@̗\qW̃Xg
var CP=[[1.0],[1.5,-0.5],[23.0/12.0,-16.0/12.0,5.0/12.0],
      	[55.0/24.0,-59.0/24.0,37.0/24.0,-9.0/24.0],
      	[1901.0/720.0,-277.0/720.0,2616.0/720.0,-1274.0/720.0,251.0/720.0]];
// A_X|oVtH[X|[g@̕␳qW̃Xg
var CC=[[0.5,0.5],[0.5,0.5],[5.0/12.0,8.0/12.0,-1.0/12.0],
      	[9.0/24.0,19.0/24.0,-5.0/24.0,1.0/24.0],
      	[251.0/720.0,646.0/720.0,-264.0/720.0,106.0/720.0,-19.0/720.0]];

// 
function initDrop(){
  initThree();
  initLight();
  initCamera();
  initObject();
  loop();
}

// three.js ̏
function initThree(){
  canvasFrame=document.getElementById('drop-canvas');
  renderer=new THREE.WebGLRenderer({antialias:true});
  if(!renderer){
    alert("three.js ̏Ɏs܂");
  }

  renderer.setSize(canvasFrame.clientWidth,canvasFrame.clientHeight);
  canvasFrame.appendChild(renderer.domElement);
  size=Math.min(canvasFrame.clientWidth,canvasFrame.clientHeight);

  renderer.setClearColor(0x000000,1.0);
  scene=new THREE.Scene();

  var info=document.getElementById('info-canvas');
  info.style.color='rgb(255,255,255)';
  info.style.backgroundColor='rgb(0,0,0)';
  height=document.getElementById('height');
  volume=document.getElementById('volume');
}

// 
function initLight(){
  directionalLight=new THREE.DirectionalLight(0xffffff,1.0);
  directionalLight.position.set(0,1.4*size,3*size);
  scene.add(directionalLight);
  ambientLight=new THREE.AmbientLight(0xcccccc);
  scene.add(ambientLight);
}

// J
function initCamera(){
  var perspect=document.getElementById('perspective').value;
  var aspect=canvasFrame.clientWidth/canvasFrame.clientHeight;
  if(perspect=='orthographic'){
    camera=new THREE.OrthographicCamera
      (-0.5*size*aspect,0.5*size*aspect,0.5*size,-0.5*size,1,10000);
  }
  else{
    camera=new THREE.PerspectiveCamera(24,aspect,0.1,10000);
  }
  var viewPoint=1.6*size;
  camera.position.set(viewPoint,viewPoint,viewPoint);
  camera.up.set(0,0,1);
//  camera.lookAt({x:0,y:0,z:0});	Controlsgp͖

  trackball=new THREE.TrackballControls(camera,canvasFrame);
  trackball.screen.width=canvasFrame.clientWidth;
  trackball.screen.height=canvasFrame.clientHeight;
  trackball.screen.offetLeft=canvasFrame.getBoundingClientRect().left;
  trackball.screen.offetTop=canvasFrame.getBoundingClientRect().top;

  trackball.noRotate=false;
  trackball.rotateSpeed=4.0;
  trackball.noZoom=false;
  trackball.zoomSpeed=4.0;
  trackball.noPan=false;
  trackball.panSpeed=1.0;
  trackball.target=new THREE.Vector3(0,0,0);
  trackball.staticMoving=true;
  trackball.dynamicDampingFactor=0.3;
}

// eݒ肷
function setPerspective(){
  camera=null;
  trackball=null;
  initCamera();
}

// \IuWFNg
function initObject(){
  var floorSize=1.6*size;
  var floorGeom=new THREE.PlaneGeometry(floorSize,floorSize);
  var floorMat=new THREE.MeshStandardMaterial
    ({color:0x3333ff,roughness:0.7,metalness:0.5,side:THREE.DoubleSide});
  floor=new THREE.Mesh(floorGeom,floorMat);
  floor.position.set(0,0,0);
  scene.add(floor);
  drawDrop();
}

// tH`ĕ`悷
function draw(){
  scene.remove(drop);
  drop=null;
  drawDrop();
}

// tH`悷
function drawDrop(){
  createDrop();
  drop.position.set(0,0,0);
  drop.rotation.set(Math.PI/2,0,0);
  scene.add(drop);
  height.textContent='height='+ht.toFixed(3);
  volume.textContent='volume='+vol.toFixed(3);
}

// [v֐
var step=0;
function loop(){
  trackball.update();
  step++;
  renderer.render(scene,camera);
  requestAnimationFrame(loop);
}

// tH`쐬
function createDrop(){
  var N=181;
  var dth=Math.PI/(N-1);
  var beta=document.getElementById('beta').value;
  var ca=Math.PI/180*document.getElementById('ca').value;
  var t=[],r=[],gamma=[];		// ƍWErWEڐGp
  var n=createDropShape(N,dth,beta,ca,t,r,gamma);
  var x=[],y=[];
  vol=0.0;
  x[0]=r[0]*Math.sin(t[0]);
  y[0]=r[0]*Math.cos(t[0]);
  for(var i=1;i<n;i++){
    x[i]=r[i]*Math.sin(t[i]);
    y[i]=r[i]*Math.cos(t[i]);
    vol+=(y[i-1]-y[i])*(x[i-1]*(x[i-1]+x[i])+x[i]*x[i]);
  }
  vol*=Math.PI/(3.0*x[n-1]*x[n-1]*x[n-1]);
  ht=Math.abs((y[n-1]-1.0)/x[n-1]);
  var cf=0.3*size/x[n-1];
  var points=[];
  for(i=0;i<n;i++){
    points[i]=new THREE.Vector2(cf*x[n-i-1],cf*(y[n-i-1]-y[n-1]));
  }
  var dropGeom=new THREE.LatheGeometry(points,36);
  dropGeom.computeVertexNormals();
  var dropMat=new THREE.MeshStandardMaterial
    ({color:0x00ffff,roughness:0.3,metalness:0.3});
  drop=new THREE.Mesh(dropGeom,dropMat);
}

// tHfʌ`쐬
// n - f[^_̍ől
// dt - ƍW̑
// beta - W
// gamma0 - ڐGp̍ől
// t,r - ,rW̃Xg
// gamma - pxi[郊Xg
function createDropShape(n,dt,beta,gamma0,t,r,gamma){
  var dr=[],drr1=[],drr2=[];
  t[0]=0.0;
  r[0]=1.0;
  dr[0]=0.0;
  drr1[0]=dr[0];
  drr2[0]=laplaceP(t[0],r[0],dr[0],beta);
  for(var i=1;i<n;i++){
    t[i]=t[i-1]+dt;
    var i2=Math.min(i-1,4);
    var drp=0.0;
    var dr2p=0.0;
    for(var j=0;j<CP[i2].length;j++){
      drp+=CP[i2][j]*drr1[i-j-1];
      dr2p+=CP[i2][j]*drr2[i-j-1];
    }
    drp=r[i-1]+dt*drp;
    dr2p=dr[i-1]+dt*dr2p;
    drr1[i]=dr2p;
    drr2[i]=laplaceP(t[i],drp,dr2p,beta);
    drp=0.0;
    dr2p=0.0;
    for(j=0;j<CC[i2].length;j++){
      drp+=CC[i2][j]*drr1[i-j];
      dr2p+=CC[i2][j]*drr2[i-j];
    }
    r[i]=r[i-1]+dt*drp;
    dr[i]=dr[i-1]+dt*dr2p;
    var dy=dr[i]*Math.cos(t[i])-r[i]*Math.sin(t[i]);
    var dx=dr[i]*Math.sin(t[i])+r[i]*Math.cos(t[i]);
    if(Math.abs(dx)===0.0){
      gamma[i]=0.5*Math.PI;
    }
    else if(dx<0.0){
      gamma[i]=Math.PI-Math.atan(dy/dx);
    }
    else{
      gamma[i]=-Math.atan(dy/dx);
    }
    if(dy>0.0) gamma[i]+=Math.PI;
    if(gamma[i]>gamma0){
      var cf=(gamma0-gamma[i-1])/(gamma[i]-gamma[i-1]);
      gamma[i]=gamma0;
      t[i]=t[i-1]+cf*(t[i]-t[i-1]);
      r[i]=r[i-1]+cf*(r[i]-r[i-1]);
      return i+1;
    }
    else if(r[i]<=0.0){
      return i;
    }
  }
  return n;
}

// tH̃vX (ɍW) rW2KvZĕԂ
// t - ƍW
// r - rW
// dr - rW1K
// beta - W
function laplaceP(t,r,dr,beta){
  if((Math.sin(t)<=0.0) || (Math.abs(r)===0.0)){
    return 0.0;
  }
  else{
    var dr2=r*r+dr*dr;
    return dr2/r*(Math.sqrt(dr2)*(beta*(r*Math.cos(t)-1.0)-2.0)
      	  -(dr*Math.cos(t)/(r*Math.sin(t))-3.0))-r;
  }
}
